import sys

sys.path.append('..')
sys.path.append('../..')

from db.mysql_db import DB
import config


class BasePublish(object):
    def __init__(self, source_table=None, dest_table=None):
        source_db = '''mysql+mysqlconnector://{0}:{1}@{2}:{3}/{4}'''.format(config.rl_db_user,
                                                                            config.rl_db_pwd,
                                                                            config.rl_db_host,
                                                                            config.rl_db_port,
                                                                            config.rl_db_database)
        destination_db = '''mysql+mysqlconnector://{0}:{1}@{2}:{3}/{4}'''.format(config.pub_db_user,
                                                                                 config.pub_db_pwd,
                                                                                 config.pub_db_host,
                                                                                 config.pub_db_port,
                                                                                 config.pub_db_database)
        # 源数据库
        self.db = DB(source_db)
        self.pub_db = DB(destination_db)
        self.source_table = source_table
        self.dest_table = dest_table

    def _get_start_date(self):
        sql = """select max(trade_date) as trade_date from `{0}`;""".format(self.dest_table)
        trades_sets = self.pub_db.query_sql(sql)
        td = 20070101
        if not trades_sets.empty:
            ts = trades_sets['trade_date'][0]
            if ts is None or ts == 'None':
                return td
            td = str(ts).replace('-', '')
        return td

    def _update_publish_log(self, tm, table=None):
        if table is None:
            table = self.dest_table
        sql = """insert into  publish_log (task_name,max_tag) values ('{0}','{1}') 
                ON DUPLICATE KEY UPDATE task_name='{0}',max_tag='{1}'""".format(table, tm)
        sql = sql.replace('\n', '')
        self.db._execute_sql(sql)
        print(f'更新{table}的max_tag为{tm}')

    def _get_source_max_update_time(self, table=None):
        if table is None:
            table = self.source_table
        sql = f'select max(update_time)as tm from `{table}`'
        result = self.db.query_sql(sql)
        result['tm'] = result['tm'].astype('str')
        tm = '0'
        if not result.empty:
            tm = result['tm'][0]
        return tm

    def _get_max_tm_log(self, table=None):
        if table is None:
            table = self.dest_table
        sql = """select max_tag from publish_log where task_name='{0}'""".format(table)
        trades_sets = self.db.query_sql(sql)
        tm = '0'
        if not trades_sets.empty:
            tm = str(trades_sets['max_tag'][0])
        return tm

    def get_source_table_sql(self):
        sql = f'SHOW CREATE table `{self.source_table}`;'
        result = self.db.query_sql(sql)
        return result['Create Table'][0]

    # 创建目标表
    def create_dest_tables(self):
        self._update_publish_log(0)
        self.pub_db._execute_sql(f'drop table if exists `{self.dest_table}`')
        create_sql = self.get_source_table_sql()
        self.pub_db._execute_sql(create_sql)

    def get_table_columns(self, table, database, db):
        sql = """select column_name,column_type
                        from information_schema.columns
                        where table_name='{0}' and table_schema='{1}'
                        order by column_name;
                """.format(table, database)
        result = db.query_sql(sql)
        return result

    def check_table_columns(self):
        source_table_column = self.get_table_columns(self.source_table, config.db_database, self.db)
        dest_table_column = self.get_table_columns(self.dest_table, config.pub_db_database, self.pub_db)
        if dest_table_column.empty:
            self.create_dest_tables()
            return
        from pandas.testing import assert_frame_equal
        try:
            assert_frame_equal(source_table_column, dest_table_column)
            print(f'{self.source_table}与发布库{self.dest_table}表结构一致。')
        except Exception as e:
            print(f'{self.source_table}与发布库{self.dest_table}表结构不一致，请检查数据库。')
            print(source_table_column)
            print(dest_table_column)
            sys.exit(1)
            # self.create_dest_tables()
